package StarFlight;

import java.awt.Color;
import java.awt.Graphics;

// ein Stern in Java...
final class Star
{
  private int x,y, vx;
  private Color color;
  private byte size;

  public Star(int MaxX, int MaxY)
  {
    init(MaxY);
    x = (int) (3 + (MaxX-6) * Math.random());
  }

  public void moveOn(int MaxX, int MaxY)
  {
    if ((x += vx) >= MaxX-3)
      init(MaxY);
  }

  public void drawMe(Graphics G)
  {
    G.setColor(color);
    drawStar(G);
  } // drawMe()

  public void undrawMe(Graphics G)
  {
    G.setColor(Color.black);
    drawStar(G);
  } // drawMe()

  private void drawStar(Graphics G)
  {
    switch (size)
    {
      case 3:
        G.drawLine(x-3,y  ,x+3,y  );
        G.drawLine(x  ,y-3,x  ,y+3);
        G.drawLine(x-2,y-2,x+2,y+2);
        G.drawLine(x-2,y+2,x+2,y-2);
        break;
      case 2:
        G.drawLine(x-3,y  ,x+3,y  );
        G.drawLine(x  ,y-3,x  ,y+3);
        G.drawLine(x-1,y-1,x+1,y+1);
        G.drawLine(x-1,y+1,x+1,y-1);
        break;
      case 1:
        G.drawLine(x-1,y  ,x+1,y  );
        G.drawLine(x  ,y-1,x  ,y+1);
        break;
      default:
        G.drawLine(x,y,x,y);
    } // switch
  } // drawStar()

  private void init(int MaxY)
  {
    double entfernung = (1 + 20 * Math.random());

    vx = (int) (42 / entfernung);
    y = (int) (3 + (MaxY-6) * Math.random());
    x = vx;

    int light = (int) (255 * (1 - entfernung / 64));
    color = new Color( light, light, light );

	size = (byte) (3 - entfernung/4);
	if (size < 0)
		size=0;
  } // init()

} // class Star

